-- the interfaces  controller
require("controllerfunctions")

module (..., package.seeall)

default_action = "loaded"

loaded = function(self)
	return self.model.get_loaded_packages()
end

available = function(self)
	return self.model.get_available_packages()
end

details = function(self)
	return self.model.get_package_details(self.clientdata.package)
end

delete = function(self)
	return self:redirect_to_referrer(self.model.delete_package(self.clientdata.package or "", self.sessiondata))
end

install = function(self)
	return self:redirect_to_referrer(self.model.install_package(self.clientdata.package or "", self.sessiondata))
end

upgrade = function(self)
	return self:redirect_to_referrer(self.model.upgrade_package(self.clientdata.package or "", self.sessiondata))
end

cache = function(self)
	return controllerfunctions.handle_form(self, self.model.get_cache, self.model.update_cache, self.clientdata, "Save", "Edit Cache Settings", "Settings Saved")
end

expert = function(self)
	return controllerfunctions.handle_form(self, self.model.get_configfile, self.model.update_configfile, self.clientdata, "Save", "Edit Configuration", "Configuration Saved")
end

updateall = function(self)
	return self:redirect_to_referrer(self.model.update_all())
end

upgradeall = function(self)
	return self:redirect_to_referrer(self.model.upgrade_all())
end
